<script lang="ts">
  // Note: adapted from https://svelte.dev/examples/modal

  // Define props
  export let showDialog: boolean;

  let dialog: HTMLDialogElement;

  $: if (dialog && showDialog) {
    dialog.showModal();
  } else if (dialog) {
    dialog.close();
  }
</script>

<!-- svelte-ignore a11y-click-events-have-key-events a11y-no-noninteractive-element-interactions -->
<dialog
  bind:this={dialog}
  on:close={() => (showDialog = false)}
  on:click|self={() => dialog.close()}
  class="fixed my-0 mr-0 h-screen max-h-full w-full max-w-lg border-none p-0 backdrop:bg-black/30"
>
  <!-- svelte-ignore a11y-no-static-element-interactions -->
  <div on:click|stopPropagation class="p-4">
    <!-- svelte-ignore a11y-autofocus -->
    <button
      autofocus
      on:click={() => dialog.close()}
      type="button"
      class="float-right -mr-1 -mt-1 mb-2 ml-2 inline-flex h-8 w-8 items-center justify-center rounded-lg bg-transparent text-slate-400 hover:bg-slate-200 hover:text-slate-600"
    >
      <svg class="h-5 w-5" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"
        ><path
          fill="none"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
          stroke-width="2"
          d="M18 6L6 18M6 6l12 12"
        /></svg
      >
      <span class="sr-only">Sluit</span>
    </button>

    <slot name="header" />
    <slot />
    <slot name="footer" />
  </div>
</dialog>

<style lang="postcss">
  dialog[open] {
    animation: slide 0.3s ease-in-out;
  }

  @keyframes slide {
    from {
      @apply mr-[-100%];
    }
    to {
      @apply mr-0;
    }
  }

  dialog[open]::backdrop {
    animation: fade 0.2s ease-out;
  }

  @keyframes fade {
    from {
      opacity: 0;
    }
    to {
      opacity: 1;
    }
  }
</style>
